/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_StressAgents;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_StressAgents;


/**
 * This class represents StressAgents_CID3204
 */
public class StressAgents_CID3204 
{
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new StressAgents_CID3204 Template 
	 */
	public StressAgents_CID3204()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumStressAgents Object of EnumCM_StressAgents represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_StressAgents enumStressAgents)
	{
		switch(enumStressAgents)
		{
		case DIPYRIDAMOLE: this.strCodeValue =EnumCV_StressAgents.DIPYRIDAMOLE_C_81590.getValue(); break;
		case DOBUTAMINE: this.strCodeValue =EnumCV_StressAgents.DOBUTAMINE_C_68030.getValue(); break;
		case ADENOSINE: this.strCodeValue =EnumCV_StressAgents.ADENOSINE_C_80349.getValue(); break;
		case ATROPINE: this.strCodeValue =EnumCV_StressAgents.ATROPINE_C_67770.getValue(); break;
		case ADENOSINE_A2_RECEPTOR_AGONIST: this.strCodeValue =EnumCV_StressAgents.ADENOSINE_A2_RECEPTOR_AGONIST_C_80012.getValue(); break;

		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumStressAgents Object of EnumCM_StressAgents represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_StressAgents enumStressAgents)
	{
		switch(enumStressAgents)
		{
		case DIPYRIDAMOLE: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.DIPYRIDAMOLE.getSNOMEDCTID(); break;
		case DOBUTAMINE: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.DOBUTAMINE.getSNOMEDCTID(); break;
		case ADENOSINE: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.ADENOSINE.getSNOMEDCTID(); break;
		case ATROPINE: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.ATROPINE.getSNOMEDCTID(); break;
		case ADENOSINE_A2_RECEPTOR_AGONIST: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.ADENOSINE_A2_RECEPTOR_AGONIST.getSNOMEDCTID(); break;

		}
	}

	/**
	 * Sets the value for StressAgents
	 * @param enumStressAgents Object of EnumCM_StressAgents.
	 */
	public void setStressAgents(EnumCM_StressAgents enumStressAgents)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumStressAgents.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumStressAgents);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumStressAgents);
	}
}
